{{ DRV8711_SPI.spin }}
CON
  SETUP      =  $1000000
  RD_12BIT   =  $2000000  ' do these need to be powers?
  WR_12BIT   =  $4000000

VAR

  long command[2]
  word cog


PUB Start (sclkpin, misopin, mosipin) | delaycount
  delaycount := 80
  command[1] := delaycount
  command[0] := SETUP | ((mosipin & $1F) << 10) | ((misopin & $1F) << 5) | (sclkpin & $1F)
  'if cog == 0 ' not sure cog is inited to zero
  cog := 1+cognew (@SPIasm, @command)
  if cog > 0
    repeat until command[0] == 0
  result := cog-1

PUB Stop
  if cog > 0
    cogstop (cog-1)
    cog := 0

PUB read12BitReg (CSpin, reg) | mask
  mask := 1 << CSpin
  OUTA |= mask
  command[0] := RD_12BIT | (reg & 7)
  repeat until command[0] == 0
  result := command[1]
  OUTA &= !mask

PUB write12BitReg (CSpin, reg, val) | mask
  mask := 1 << CSpin
  OUTA |= mask
  command[1] := val & $FFF
  command[0] := WR_12BIT | (reg & 7)
  repeat until command[0] == 0
  OUTA &= !mask


DAT

                ORG     0

SPIasm
:waitcmd	rdlong  op, par  wz
	if_z	jmp	#:waitcmd
                mov     parm, par
                add     parm, #4

		test	op, OP_RD_12BIT  wz
	if_nz	call	#read12bit
		test	op, OP_WR_12BIT  wz
	if_nz	call	#write12bit

		test	op, OP_SETUP  wz
	if_nz	call	#setup_pins

		mov	op, #0
		wrlong  op, par
		jmp	#:waitcmd

setup_pins
		call	#get_pin
		mov	SCK_PIN, pin
		call	#get_pin
		mov	MISO_PIN, pin
		call	#get_pin
		mov	MOSI_PIN, pin

                or      dira, MOSI_PIN
                or      dira, SCK_PIN
		rdlong	bitdel, parm	' get the delay value
setup_pins_ret  ret


get_pin		mov	t, op
		shr	op, #5
		and	t, #$1F
		mov	pin, #1
		shl	pin, t
get_pin_ret	ret




write12bit	and	op, #7
		shl	op, #12
                rdlong  tmp, parm
                and     tmp, HFFF
                mov     t, CNT
                add     t, bitdel
                or      op, tmp
                shl     op, #16
		call	#spibyte
		call	#spibyte
write12bit_ret   ret

read12bit       and     op, #7
                mov     t, CNT
                add     t, bitdel
                or      op, #8
                shl     op, #28
                call    #spibyte
                call    #spibyte
                and     resultword, HFFF
                wrlong  resultword, parm
read12bit_ret   ret




spibyte		mov	count, #8
:loop
		rcl	op, #1  wc
                waitcnt t, bitdel
		andn	outa, SCK_PIN
		muxc	outa, MOSI_PIN
		waitcnt t, bitdel
		or	outa, SCK_PIN
		test	MISO_PIN, ina  wc
		rcl	resultword, #1
		djnz	count, #:loop
spibyte_ret	ret

HFFF            long    $00000FFF
SCK_PIN		long	$10000
MISO_PIN	long	$20000
MOSI_PIN	long	$40000

OP_SETUP        long    SETUP
OP_RD_12BIT     long    RD_12BIT
OP_WR_12BIT     long    WR_12BIT

bitdel          long    80

parm            res     1
arg             res     1
op              res     1
tmp             res     1
buffer          res     1

pin             res     1
c		res	1
t		res	1
resultword      res     1
count		res	1

		FIT	$1F0
